org.apache.http.protocol

## Class ImmutableHttpProcessor

- java.lang.Object
- - org.apache.http.protocol.ImmutableHttpProcessor

All Implemented Interfaces:
  HttpRequestInterceptor, HttpResponseInterceptor, HttpProcessor

    @ThreadSafe
    public final class ImmutableHttpProcessor
    extends Object
    implements HttpProcessor

Immutable `HttpProcessor`.

Since:
  4.1

### Constructor Summary

Constructors
Constructor and Description
`ImmutableHttpProcessor(HttpRequestInterceptor... requestInterceptors)`
`ImmutableHttpProcessor(HttpRequestInterceptor[] requestInterceptors, HttpResponseInterceptor[] responseInterceptors)`
`ImmutableHttpProcessor(HttpRequestInterceptorList requestInterceptors, HttpResponseInterceptorList responseInterceptors)` Deprecated. (4.3) do not use.
`ImmutableHttpProcessor(HttpResponseInterceptor... responseInterceptors)`
`ImmutableHttpProcessor(List<HttpRequestInterceptor> requestInterceptors, List<HttpResponseInterceptor> responseInterceptors)`

### Method Summary

Methods
`void` `process(HttpRequest request, HttpContext context)` Processes a request.
`void` `process(HttpResponse response, HttpContext context)` Processes a response.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ImmutableHttpProcessor

    public ImmutableHttpProcessor(HttpRequestInterceptor[] requestInterceptors,
                          HttpResponseInterceptor[] responseInterceptors)

#### ImmutableHttpProcessor

    public ImmutableHttpProcessor(List<HttpRequestInterceptor> requestInterceptors,
                          List<HttpResponseInterceptor> responseInterceptors)

Since:
  4.3

#### ImmutableHttpProcessor

    @Deprecated
    public ImmutableHttpProcessor(HttpRequestInterceptorList requestInterceptors,
                                     HttpResponseInterceptorList responseInterceptors)

Deprecated. (4.3) do not use.

#### ImmutableHttpProcessor

    public ImmutableHttpProcessor(HttpRequestInterceptor... requestInterceptors)

#### ImmutableHttpProcessor

    public ImmutableHttpProcessor(HttpResponseInterceptor... responseInterceptors)

### Method Detail

#### process

    public void process(HttpRequest request,
               HttpContext context)
                 throws IOException,
                        HttpException

Description copied from interface: `HttpRequestInterceptor`
Processes a request. On the client side, this step is performed before the request is sent to the server. On the server side, this step is performed on incoming messages before the message body is evaluated.

Specified by:
  `process` in interface `HttpRequestInterceptor`
Parameters:
  `request` - the request to preprocess
  `context` - the context for the request
Throws:
  `IOException` - in case of an I/O error
  `HttpException` - in case of an HTTP protocol violation

#### process

    public void process(HttpResponse response,
               HttpContext context)
                 throws IOException,
                        HttpException

Description copied from interface: `HttpResponseInterceptor`
Processes a response. On the server side, this step is performed before the response is sent to the client. On the client side, this step is performed on incoming messages before the message body is evaluated.

Specified by:
  `process` in interface `HttpResponseInterceptor`
Parameters:
  `response` - the response to postprocess
  `context` - the context for the request
Throws:
  `IOException` - in case of an I/O error
  `HttpException` - in case of an HTTP protocol violation